---
title: 'SyntaxError: missing ; before statement'
slug: Web/JavaScript/Reference/Errors/Missing_semicolon_before_statement
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "missing ; before statement" occurs when there is a semicolon (<code>;</code>) missing somewhere and can't be added by <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Automatic_semicolon_insertion">automatic semicolon insertion (ASI)</a>. You need to provide a semicolon, so that JavaScript can parse the source code correctly.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: Expected ';' (Edge)
SyntaxError: missing ; before statement (Firefox)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}.</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>There is a semicolon (<code>;</code>) missing somewhere. <a href="/en-US/docs/Web/JavaScript/Reference/Statements">JavaScript statements</a> must be terminated with semicolons. Some of them are affected by <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Automatic_semicolon_insertion">automatic semicolon insertion (ASI)</a>, but in this case you need to provide a semicolon, so that JavaScript can parse the source code correctly.</p>

<p>However, oftentimes, this error is only a consequence of another error, like not escaping strings properly, or using <code>var</code> wrongly. You might also have too many parenthesis somewhere. Carefully check the syntax when this error is thrown.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Unescaped_strings">Unescaped strings</h3>

<p>This error can occur easily when not escaping strings properly and the JavaScript engine is expecting the end of your string already. For example:</p>

<pre class="brush: js example-bad">var foo = 'Tom's bar';
// SyntaxError: missing ; before statement</pre>

<p>You can use double quotes, or escape the apostrophe:</p>

<pre class="brush: js example-good">var foo = "Tom's bar";
var foo = 'Tom\'s bar';
</pre>

<h3 id="Declaring_properties_with_var">Declaring properties with var</h3>

<p>You <strong>cannot</strong> declare properties of an object or array with a <code>var</code> declaration.</p>

<pre class="brush: js example-bad">var obj = {};
var obj.foo = 'hi'; // SyntaxError missing ; before statement

var array = [];
var array[0] = 'there'; // SyntaxError missing ; before statement
</pre>

<p>Instead, omit the <code>var</code> keyword:</p>

<pre class="brush: js example-good">var obj = {};
obj.foo = 'hi';

var array = [];
array[0] = 'there';
</pre>

<h3 id="Bad_keywords">Bad keywords</h3>

<p>If you come from another programming language, it is also common to use keywords that don't mean the same or have no meaning at all in javaScript:</p>

<pre class="brush: js example-bad">def print(info){
  console.log(info);
}; // SyntaxError missing ; before statement</pre>

<p>Instead, use <code>function</code> instead of <code>def</code>:</p>

<pre class="brush: js example-good">function print(info){
  console.log(info);
};</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Automatic_semicolon_insertion">Automatic semicolon insertion (ASI)</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements">JavaScript statements</a></li>
</ul>
